<!doctype html>
<html lang="en">
<head>
<title>90-usr-merge-bof</title>
<meta name="generator" content="Etherpad">
<meta name="author" content="Etherpad">
<meta name="changedby" content="Etherpad">
<meta charset="utf-8">
<style>
ol {
  counter-reset: item;
}

ol > li {
  counter-increment: item;
}

ol ol > li {
  display: block;
}

ol > li {
  display: block;
}

ol > li:before {
  content: counters(item, ".") ". ";
}

ol ol > li:before {
  content: counters(item, ".") ". ";
  margin-left: -20px;
}

ul.indent {
  list-style-type: none;
}


</style>
</head>
<body>
<span class="anonymous" title="anonymous">/usr-merge bof</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="anonymous" title="anonymous">DEP17 preview: https://subdivi.de/~helmut/dep17.html</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="anonymous" title="anonymous">Status:</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><ul class="bullet"><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">problems understood and documented (hopefully)</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></li><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">consensus reached</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><ul class="bullet"><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">Primary mechanism is moving files from / to /usr</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></li><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">Bootstrap protocol is being retained, needs debootstrap update</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></ul><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">initial steps implemented, more patches filed</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><ul class="bullet"><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">DEP17-P2 (trigger) patches filed</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></li><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">DEP17-P6 (empty directory) patches partially filed</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></li><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">DEP17-P8 (bootstrap) debootstrap patched in unstable, propagating to oldstable</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></li><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">DEP17-P10 (d-i) patch filed</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></li><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">Started moving systemd units from / to /usr (violates moratorium)</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></ul></li></ul><span class="anonymous" title="anonymous">Next steps:</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><ul class="bullet"><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">Progressively lift the moratorium</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></li><li><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">*</span><span class="anonymous" title="anonymous">Change debhelper to install more files to /usr</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span></ul><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="anonymous" title="anonymous">Q&A</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_rVXBGOEuaLy6ShUj" title="a_rVXBGOEuaLy6ShUj" style="background-color:#ad83b5"></span><br><span class="anonymous" title="anonymous">• could we have an official response from usrmerge proponents wrt what the benefits for _Debian_ are?  Because despite repeatedly asking, all we get are links to that poynter website which says: 1. compat with Solaris (dead), 2. booting with libs from / (an unrelated problem), 3. an abandoned Red Hat PoC who went with btrfs/overlays/lvm/etc solutions instead.  Since then, I've heard about compat with Red Hat -- which is also on last acts of its Solaris-like collapse (well, Solaris is technically alive, and raking millions of dollars from enterprise customers, but its effects on development in the last decades are nil).  It's also a false claim that most of the linux ecosystem has migrated to usrmerge; when I spent time checking which distros have migrated, all I got outside he Debian tree (where dpkg doesn't support usrmerge) was Red Hat and Arch, with nay-sayers being Gentoo, Slack, FreeBSD, OpenBSD; and Hurd a reverse case.  I did not check many others as it takes a long time to install a distro you're unfamiliar with -- but if there's an actual interest in an answer, I can re-check/check more.</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">This is out of scope. The scope of this bof is finishing the transition somehow and getting the moratorium lifted.</span><br><span class="a_rVXBGOEuaLy6ShUj" title="a_rVXBGOEuaLy6ShUj" style="background-color:#ad83b5"></span><br><span class="anonymous" title="anonymous">• even if we _do_ stick with usrmerge, at this point it's beyond obvious that the current path will take multiple releases and man-years of work to get it done (just look at this very DEP17 for example).  Why not go with any of other ways, like the one proposed by Guillem et al years ago, and re-reraised by Ian recently?  Moving files when there are no aliases on the filesystem is trivial and needs no moratorium, thus briefly un-merging (by a Pre-Depends on an unmerging version of dpkg) then re-merging is simple and safe.</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">This is not as easy as it initially sounds. For one thing, more and more packages are assuming the aliasing layout and e.g. drop /bin from $PATH or use /usr/bin/sh or something. For another, dpkg-fsys-usrunmess is much less safe than usrmerge. Just for supporting split-/usr as an alternative layout we'd have to do a lot of work.</span><br><span class="a_rVXBGOEuaLy6ShUj" title="a_rVXBGOEuaLy6ShUj" style="background-color:#ad83b5"></span><br><span class="anonymous" title="anonymous">• what with security issues caused by usrmerge (of which I know at least two)?  There's been not a word about them; shouldn't discuss that in a publicly recorded session, but ignoring such problems is no good.</span><span class="a_Z8ekuqMYJ277aHD6" title="a_Z8ekuqMYJ277aHD6" style="background-color:#d7b0b8"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Please refer security issues to the security team. This is about removing the moratorium and associated mental cost. Other aspects of /usr-merge are to be dealt with separately. </span><span class="a_Z8ekuqMYJ277aHD6" title="a_Z8ekuqMYJ277aHD6" style="background-color:#d7b0b8">Philip Hands wondered if you're going to provide references to the cases you're alluding to.</span><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d">How can people help with the transition? A lot of sourceful uploads seem to be needed, how is it possible to help with that for instance?</span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d">Helmut says: there is a split between some Debian tooling changes needed, and some upstream changes needed, and these need to be classified. Systemd units need to be moved from /lib to /usr/lib (violating the current moratorium), this is around half of the packages that need changes, for instance.</span><span class="a_IR0fnueHW3TrHNW8" title="a_IR0fnueHW3TrHNW8" style="background-color:#b6f9b3"> It is unknown which of these packages use debhelper to install the units or rely on an upstream build system / d/*.install.</span><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d">If you want to do structural changes, please upload them to experimental so that the "/usr-merge CI" tools can look at them and verify that they're adequate.</span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d">The usr merge wiki page will list the bits of the moratorium that can be violated, once there has been an announcement on d-d-a about it.</span><span class="a_efSGOgh8HoL269ns" title="a_efSGOgh8HoL269ns" style="background-color:#47f7f2"></span><br><span class="a_efSGOgh8HoL269ns" title="a_efSGOgh8HoL269ns" style="background-color:#47f7f2"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Idea: Use the Debian janitor for moving systemd units</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Wish: More tutorial-style documentation</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Wish: More summaries of long discussions</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Wish: Put up a flow diagram for the sequence of events</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Wish: Put up an actual timeline</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Wish: Communicate with invol</span><span class="a_IR0fnueHW3TrHNW8" title="a_IR0fnueHW3TrHNW8" style="background-color:#b6f9b3">v</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">ed parties and get their agreement</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Wish: broaden the audience to d-devel with something actionable before going to d-d-a</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Accept some breakage. The perfect is the enemy of the good. Removing the remaining percentage of risk has an unreasonable cost.</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">Wish: integrate dumat into salsa-ci</span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9"></span><br><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">General sentiment: This work </span><span class="a_Z8ekuqMYJ277aHD6" title="a_Z8ekuqMYJ277aHD6" style="background-color:#d7b0b8">h</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">as signifiant backing of the project and if stuff breaks, it is no longer an individual</span><span class="a_Z8ekuqMYJ277aHD6" title="a_Z8ekuqMYJ277aHD6" style="background-color:#d7b0b8">'</span><span class="a_vLrcAPLcz0BO1uN1" title="a_vLrcAPLcz0BO1uN1" style="background-color:#a268d9">s responsibility but a collective responsibility.</span><span class="a_efSGOgh8HoL269ns" title="a_efSGOgh8HoL269ns" style="background-color:#47f7f2"></span><br><span class="a_efSGOgh8HoL269ns" title="a_efSGOgh8HoL269ns" style="background-color:#47f7f2"></span><br><span class="a_efSGOgh8HoL269ns" title="a_efSGOgh8HoL269ns" style="background-color:#47f7f2"></span><br><span class="a_efSGOgh8HoL269ns" title="a_efSGOgh8HoL269ns" style="background-color:#47f7f2"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="a_Wh6QyvW83GVpStvB" title="a_Wh6QyvW83GVpStvB" style="background-color:#9a017d"></span><br><span class="anonymous" title="anonymous"></span><br>
</body>
</html>
